ClientApp/Controllers/KarkardController.cs
using ClientApp.Api;
using GabAPI.Models.Inputs.CustomerShop;
using GabAPI.Models.Inputs.KarKard;
using GabAPI.Models.Outputs.Customer;
using GabAPI.Models.Outputs.CustomerShop;
using GabAPI.Models.Outputs.KarKard;
using System;
using System.Web.Mvc;

namespace ClientApp.Controllers
{
    public class KarkardController: BaseController
    {
        public ActionResult AddExpence(InputaddExpence values)
        {
            var token = GetUserToken();
            values.UserID = GetCurrentUser().Id;
            var apiResult = ApiList.AddNewExpence(values, token);
            return Content(apiResult);
        }
        public ActionResult Index()
        {
            return View();
        }
        public ActionResult AddCustomerCombo()
        {
            var partialViewUrl = "~/Views/Karkard/AddForm/AddFormCustomerCombo.cshtml";
            var dataSource = GetCustomerList();
            return PartialView(partialViewUrl, dataSource);
        }
        public ActionResult AddFormCustomerShopCombo(long CustomerId = 0)
        {
            var partialViewUrl = "~/Views/Karkard/AddForm/AddFormCustomerShopCombo.cshtml";
            var dataSource = GetCustomerShopList(CustomerId);
            return PartialView(partialViewUrl, dataSource);

        }

        public ActionResult AddPriceCombo()
        {
            var partialViewUrl = "~/Views/Karkard/AddForm/AddFormPriceCombo.cshtml";
            var dataSource = GetActivePriceList();
            return PartialView(partialViewUrl, dataSource);

        }

        public OutputGetCustomerShopListByCustomertID[] GetCustomerShopList(long CustomerID)
        {
            if(CustomerID == 0)
            {
                return new OutputGetCustomerShopListByCustomertID[0];
            }

            var apiParam = new InputGetCustomerShopListByCustomertID
            {
                CustomerID = CustomerID
            };
            var token = GetUserToken();
            return ApiList.GetCustomerShopByCustomerID(apiParam, token);
        }

        public OutputPrice[] GetActivePriceList()
        {
           
            var token = GetUserToken();
            return ApiList.GetActivePriceList(token);
        }
        public OutputGetCustomerList[] GetCustomerList()
        {
            var cacheKey = "CustomerList";
            var cachedDataSource = GetDataFromCache(cacheKey) as OutputGetCustomerList[];
            var hasCache = cachedDataSource != null && cachedDataSource.Length > 0;
            if(hasCache)
            {
                return cachedDataSource;
            }

            var dataSource = ApiList.GetAllCustomersList();
            SetDataInCache(cacheKey, dataSource, 60);
            return dataSource;
        }
        public OutputGetKarkardDetail[] GetKarkardDetail(InputGetKarkardDetail values)
        {
            var dataSource = ApiList.GetKarkardDetail(values);
            return dataSource;
        }
        public ActionResult KarkardGrid(string StartDate,string EndDate)
        {
            var partialViewUrl = "~/Views/Karkard/KarkardGrid/KarkardGrid.cshtml";
            if(string.IsNullOrEmpty(StartDate))
            {
                StartDate = Tools.Tools.GetFarsiShortDate(DateTime.Now.AddMonths(-3));
            }
            if(string.IsNullOrEmpty(EndDate))
            {
                EndDate = Tools.Tools.GetFarsiShortDate(DateTime.Now);
            }
            var item = new InputGetKarkardDetail()
            {
                StartDate = Tools.Tools.ConvertToLatinDate(StartDate),
                EndDate = Tools.Tools.ConvertToLatinDate(EndDate),
            };
            var dataSource = GetKarkardDetail(item);
            return PartialView(partialViewUrl, dataSource);
        }
    }
}

ClientApp/Views/Karkard/AddForm/AddForm.cshtml
<div class="col-xs-12 col-md-3">
    <section class="app__section">
        <div class="app__section__header">
           ثبت کارکرد جدید
        </div>
        <div class="app__section__body">
            <div class="row">
                <div class="col-xs-12 ">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            انتخاب قیمت مصوب
                        </label>
                        <div id="addPriceComboParent">
                            @{ Html.RenderAction("AddPriceCombo", "Karkard"); }
                        </div>
                        <div id="addPriceComboError"
                             class="app__form-error app__hide">
                            قیمت مصوب انتخاب نشده است
                        </div>
                    </div>
                </div>
                
            </div>

            <div class="row">
                <div class="col-xs-12 ">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            انتخاب مشتری
                        </label>
                        <div id="addFormCustomerComboParent">
                            @{ Html.RenderAction("AddCustomerCombo", "Karkard"); }
                        </div>
                        <div id="addFormCustomerComboError"
                             class="app__form-error app__hide">
                            مشتری انتخاب نشده است
                        </div>
                    </div>
                </div>
                <div class="col-xs-12 ">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            انتخاب مغازه مشتری
                        </label>
                        <div id="addCustomerShopComboParent">
                            @{ Html.RenderAction("AddFormCustomerShopCombo", "Karkard"); }
                        </div>
                        <div id="addCustomerShopComboError"
                             class="app__form-error app__hide">
                            مغازه انتخاب نشده است
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-xs-12">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            تاریخ شروع
                        </label>
                        <input type="text" class="app__form-datepicker"
                               id="addFormStartDatePicker"
                               placeholder="تاریخ شروع"
                               data-mddatetimepicker="true"
                               data-englishnumber="true"
                               data-targetdateselector="#addFormStartDatePicker" />
                        <div class="app__form-error app__hide" id="addFormStartDatePickerError">
                            فرمت تاریخ شروع معتبر نمی باشد
                        </div>
                    </div>
                </div>
                <div class="col-xs-12">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            مقدار کارکرد
                        </label>
                        <div id="addKarkardStartInputParent">
                            @Html.DevExpress().TextBox(settings =>
                            {
                                settings.Name = "addKarkardStartInput";
                                settings.Properties.NullText = "مقدار کارکرد را وارد کنید";
                            }).GetHtml()
                        </div>
                        <div id="addKarkardStartInputError"
                             class="app__form-error app__hide">
                            مقدار مصرف وارد نشده است
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-xs-12">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            تاریخ اتمام
                        </label>
                        <input type="text" class="app__form-datepicker"
                               id="AddFormEndDatePicker"
                               placeholder="تاریخ اتمام"
                               data-mddatetimepicker="true"
                               data-englishnumber="true"
                               data-targetdateselector="#AddFormEndDatePicker" />
                        <div class="app__form-error app__hide" id="AddFormEndDatePickerError">
                            فرمت تاریخ اتمام معتبر نمی باشد
                        </div>
                    </div>
                </div>
                <div class="col-xs-12">
                    <div class="app__form-item">
                        <label class="app__form-label">
                            مقدار کارکرد
                        </label>
                        <div id="addKarkardStartInputParent">
                            @Html.DevExpress().TextBox(settings =>
                            {
                                settings.Name = "addKarkardEndtInput";
                                settings.Properties.NullText = "مقدار کارکرد نهایی";
                            }).GetHtml()
                        </div>
                        <div id="addKarkardEndInputError"
                             class="app__form-error app__hide">
                            مقدار مصرف وارد نشده است
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-xs-12">
                    <div class="app__form-item app__form-item--action">
                        @Html.DevExpress().Button(settings =>
                        {
                            settings.Name = "addFormSaveBtn";
                            settings.Text = "ثبت کارکرد";
                            settings.UseSubmitBehavior = false;
                            settings.EnableClientSideAPI = true;
                            settings.Styles.CssPostfix = "filter-form__btn";
                            settings.ClientSideEvents.Click =
                                "motorsazanClient.karkard.addExpence";
                        }).GetHtml()
                    </div>
                </div>
            </div>
        </div>
    </section>
</div>

ClientApp/Views/Karkard/AddForm/AddFormCustomerCombo.cshtml
@model GabAPI.Models.Outputs.Customer.OutputGetCustomerList[]

@Html.DevExpress().ComboBox(
settings =>
{
    settings.Name = "addFormCustomerCombo";
    settings.CallbackRouteValues = new { Controller = "Karkard", Action = "AddCustomerCombo" };
    settings.Width = Unit.Percentage(100);
    settings.Properties.ValidationSettings.ErrorDisplayMode = ErrorDisplayMode.None;
    settings.Properties.NullText = "مشتری را انتخاب نمایید";
    settings.SelectedIndex = -1;
    settings.Properties.CallbackPageSize = 100;
    settings.Properties.IncrementalFilteringMode = IncrementalFilteringMode.Contains;
    settings.Properties.IncrementalFilteringDelay = 200;
    settings.SettingsLoadingPanel.Text = "در حال دریافت اطلاعات";

    settings.Properties.ValueField = "Id";
    settings.Properties.ValueType = typeof(long);
    settings.Properties.TextFormatString = "{1} {2}";
    settings.Properties.Columns.Add("Code", "کد ");
    settings.Properties.Columns.Add("FirstName", "نام");
    settings.Properties.Columns.Add("LastName", "نام خانوادگی");
    settings.Properties.Columns.Add("CustomerType", "نوع");
    settings.Properties.ClientSideEvents.SelectedIndexChanged =
    "motorsazanClient.karkard.handleAddFormCustomerComboChange";

}).BindList(Model).GetHtml()

ClientApp/Views/Karkard/AddForm/AddFormCustomerShopCombo.cshtml
@model GabAPI.Models.Outputs.CustomerShop.OutputGetCustomerShopListByCustomertID[] 

@Html.DevExpress().ComboBox(
settings =>
{
    settings.Name = "addCustomerShopCombo";
    settings.CallbackRouteValues = new { Controller = "Karkard", Action = "AddFormCustomerShopCombo" };
    settings.Width = Unit.Percentage(100);
    settings.Properties.ValidationSettings.ErrorDisplayMode = ErrorDisplayMode.None;
    settings.Properties.NullText = "خط را انتخاب نمایید";
    settings.SelectedIndex = -1;
    settings.Properties.CallbackPageSize = 100;
    settings.Properties.IncrementalFilteringMode = IncrementalFilteringMode.Contains;
    settings.Properties.IncrementalFilteringDelay = 200;
    settings.SettingsLoadingPanel.Text = "در حال دریافت اطلاعات";

    settings.Properties.ValueField = "CustomerShopID";
    settings.Properties.ValueType = typeof(long);
    settings.Properties.TextFormatString = "{0} {1}";
    settings.Properties.Columns.Add("ComplexTitle", "بازار");
    settings.Properties.Columns.Add("Pelak", "پلاک");
    settings.Properties.Columns.Add("TabloName", "عنوان");
    settings.Properties.ClientSideEvents.BeginCallback =
    "motorsazanClient.karkard.handleAddFormCustomerShopBeginCallback";

}).BindList(Model).GetHtml()

ClientApp/Views/Karkard/AddForm/AddFormPriceCombo.cshtml
@model GabAPI.Models.Outputs.KarKard.OutputPrice[]
@Html.DevExpress().ComboBox(
settings =>
{
    settings.Name = "addPriceCombo";
    settings.CallbackRouteValues = new { Controller = "Karkard", Action = "AddPriceCombo" };
    settings.Width = Unit.Percentage(100);
    settings.Properties.ValidationSettings.ErrorDisplayMode = ErrorDisplayMode.None;
    settings.Properties.NullText = "قیمت  را انتخاب نمایید";
    settings.SelectedIndex = -1;
    settings.Properties.CallbackPageSize = 100;
    settings.Properties.IncrementalFilteringMode = IncrementalFilteringMode.Contains;
    settings.Properties.IncrementalFilteringDelay = 200;
    settings.SettingsLoadingPanel.Text = "در حال دریافت اطلاعات";

    settings.Properties.ValueField = "PriceID";
    settings.Properties.ValueType = typeof(long);
    settings.Properties.TextFormatString = "{0} ";
    settings.Properties.Columns.Add("BasePrice", "قیمت").Width = 40;
    settings.Properties.Columns.Add("CreationDateTime", "تاریخ ثبت");

}).BindList(Model).GetHtml()